# -*- coding: utf-8 -*-
from operator import itemgetter
from openerp.addons.base.maintenance.migrations import util

def migrate(cr, version):
    # that's silly, we highjack the sequence field :p
    cr.execute("""
        INSERT INTO sale_subscription_close_reason(name, sequence)
            SELECT name, id FROM openerp_enterprise_close_reason
    """)

    # classic write fields
    cw_fields = util.splitlines("""
        enterprise_final_customer_id
        enterprise_technical_contact_id
        enterprise_max_db
        enterprise_saas
        enterprise_limit_exceeded
        enterprise_exception
    """)

    non_cw_fields = util.splitlines("""
        pricelist_currency_id
        database_ids
        enterprise_has_latest_pricelist
    """)

    cr.execute("""
        SELECT *
          FROM ir_model
         WHERE model IN ('sale.subscription', 'account.analytic.account')
      ORDER BY model
    """)

    [old_model, new_model] = map(itemgetter(0), cr.fetchall())
    cr.execute("""
        UPDATE ir_model_fields
           SET model='sale.subscription', model_id=%s
         WHERE model_id=%s
           AND name IN %s
     RETURNING id
    """, [new_model, old_model, tuple(cw_fields + non_cw_fields)])

    fids = list(map(itemgetter(0), cr.fetchall()))
    cr.execute("""
        UPDATE ir_model_data
           SET name='field_sale_subscription_' || substr(name, 32)
         WHERE model='ir.model.fields'
           AND res_id IN %s
    """, [tuple(fids)])

    for f in cw_fields:
        fdef = util.column_type(cr, 'account_analytic_account', f)
        util.create_column(cr, 'sale_subscription', f, fdef)

    set_values = ', '.join('{0} = a.{0}'.format(f) for f in cw_fields)

    cr.execute("""
        UPDATE sale_subscription s
           SET {0},
               recurring_next_date = a.recurring_next_date,
               recurring_rule_type = a.enterprise_mode,
               close_reason_id = r.id
          FROM account_analytic_account a, sale_subscription_close_reason r
         WHERE s.analytic_account_id = a.id
           AND a.enterprise_close_reason_id = r.sequence
    """.format(set_values))

    old_columns = util.splitlines("""
        recurring_next_date
        enterprise_mode
        enterprise_from_version
        enterprise_close_reason_id
        enterprise_has_support
        enterprise_has_migration
        enterprise_has_apps
        enterprise_max_users
        enterprise_from_version
        enterprise_monthly_price
        enterprise_yearly_price
        try_without_remind
        offplans_next_date
    """)

    for f in cw_fields + old_columns:
        util.remove_column(cr, 'account_analytic_account', f)

    cr.execute("UPDATE sale_subscription_close_reason SET sequence=10")

    # database: analytic_account -> subscription
    cr.execute("""
        UPDATE openerp_enterprise_database
           SET analytic_account_id = NULL
         WHERE analytic_account_id NOT IN (SELECT analytic_account_id FROM sale_subscription)
    """)
    cr.execute("""
        ALTER TABLE openerp_enterprise_database
    DROP CONSTRAINT IF EXISTS openerp_enterprise_database_analytic_account_id_fkey
    """)
    util.rename_field(cr, 'openerp.enterprise.database', 'analytic_account_id', 'subscription_id')
    cr.execute("""
        UPDATE openerp_enterprise_database d
           SET subscription_id = s.id
          FROM sale_subscription s
         WHERE s.analytic_account_id = d.subscription_id
    """)
